# ================================================================================== #
# === PSYCHOSTATS 3.1 - Ranks & Statistics & RealtimeCalc system for Psychostats === #
# === include autobalance based on KDR									         === #
# === Modification for Counter-Strike:Source Servers                             === #
# === Author: Ch@meleon (snake_nas@mail.ru)										 === #
# === Version: 0.2.0															 === #
# === -------------------------------------------------------------------------- === #
# ================================================================================== #
import sys
import es
import playerlib
import MySQLdb
import popuplib
import keyvalues

# ================================================================================== #
# ==========  G l o b a l   C o n f i g u r a t i o n  V a r i a b l e s  ========== #
# ================================================================================== #
# Modify the variables below to your needs...

# ===== Psycho Stats ===== #
ps_atb					= 1 				# Enables AutoBalance
ps_atb_minplayers		= 2					# Minimum players on server to ATB swap players (default 4)
ps_atb_diff				= 0.4				# Points difference to ATB swap players (default 0.4)
ps_atb_rounds			= 3					# How often rounds ATB can rebalance teams (default 5)
ps_atb_anounce			= 2					# Anouncement level when swap players (0 - disabled, 1 - show swap players, 2 - show all anouncements)
ps_atb_mover			= 1					# Enables swap players (when disabled only shown who needed to swap)
ps_realtime_calc		= 0 #not work yet	# Enables ingame realtime calc point system (disabled logs for web based calc system)
ps_rewrite_points		= 0					# Overwrite points settings from psychostats web statistic
ps_admin_anounce		= 1					# Anounce when Mani-admin join to server (tracking by uniqueId from PsychoStats)

# = Chat cmd definition == #
ps_cmd_top				= 'top'			# Top (top10) cmd
ps_cmd_session			= 'session'		# Session cmd
ps_cmd_statsme			= 'statsme'		# Statsme cmd
ps_cmd_kpd				= 'kpd'			# KPD cmd
ps_cmd_rank				= 'rank'		# Rank cmd

# ==== MySQL Settings ==== #
ps_mysql_hostname		= 'localhost'	# Server / Hostname for the mysql server (webserver), localhost if webserver is on same machine as cstrike server.
ps_mysql_username		= 'root'		# Username, needed to login on the sql server
ps_mysql_password		= ''			# Password, also needed to login on the sql server
ps_mysql_database		= 'psychostats3_1'		# Database - Where you want the data to be stored.

# ==== Stats Settings ==== #
ps_stats_multiplier		= 2				# Multiply gained points from a frag (Default:2)
ps_stats_maxpoints		= 40			# Set a max points (security reason) (Default:30)
ps_stats_headshotbonus	= 3				# Bonus points for headshots (p = (((pv/pa)*mul)*pw_mod)+hsbonus)
ps_stats_teamkill_loss	= 5				# Amount of points the attacker loses for a teamkill

ps_points_team_t_elim	= 5				# Team Points for Eliminating All Terrorists
ps_points_team_ct_elim	= 5				# Team Points for Eliminating All Counter-Terrorists
ps_points_team_bomb_bt	= 5				# Team Points for Bombing The Target
ps_points_team_bomb_d	= 5				# Team Points for Defusing the Bomb
ps_points_team_hostage_r= 5				# Team Points for All Hostages Rescued
ps_points_team_hostage_k= 2				# Team Points for Hostages Not Rescued

ps_points_bomb_planted  = 10			# Player points for Planting The Bomb
ps_points_bomb_defused  = 10			# Player points for Defusing The Bomb
ps_points_hostage_resc	= 5				# Player points for rescuing a hostage
ps_points_hostage_kill	= 3				# Player points penalty for killing a hostage

# Weapon Bonuses ( Base Points * WeaponBonus )
ps_bonus_weapon_glock			= 2
ps_bonus_weapon_usp				= 2
ps_bonus_weapon_p228			= 2
ps_bonus_weapon_deagle			= 2
ps_bonus_weapon_fiveseven		= 2
ps_bonus_weapon_elite			= 2
ps_bonus_weapon_m3				= 1
ps_bonus_weapon_xm1014			= 1
ps_bonus_weapon_tmp				= 1
ps_bonus_weapon_mac10			= 1
ps_bonus_weapon_mp5navy			= 1
ps_bonus_weapon_ump45			= 1
ps_bonus_weapon_p90				= 1
ps_bonus_weapon_famas			= 1
ps_bonus_weapon_galil			= 1
ps_bonus_weapon_ak47			= 1
ps_bonus_weapon_scout			= 2
ps_bonus_weapon_m4a1			= 1
ps_bonus_weapon_sg550			= 1
ps_bonus_weapon_g3sg1			= 1
ps_bonus_weapon_awp				= 0.5
ps_bonus_weapon_sg552			= 1
ps_bonus_weapon_aug				= 1
ps_bonus_weapon_m249			= 1
ps_bonus_weapon_hegrenade		= 4
ps_bonus_weapon_flashbang		= 1
ps_bonus_weapon_smokegrenade 	= 1
ps_bonus_weapon_knife			= 7

# ==== Language Vars ==== #
ps_txt_objective_ct_eliminated		= '#Green All Counter-Terrorists Eliminated'
ps_txt_objective_t_eliminated		= '#Green All Terrorists Eliminated'
ps_txt_objective_target_bombed		= '#Green Target Bombed'
ps_txt_objective_bomb_planted		= 'Planting the Bomb'
ps_txt_objective_bomb_defused2		= 'Defusing the Bomb'
ps_txt_objective_bomb_defused		= '#Green Defusing the Bomb'
ps_txt_objective_hostage_killed		= '#Green Killing a Hostage'
ps_txt_objective_hostage_r			= '#Green All Hostages Rescued'
ps_txt_objective_hostage_nr			= '#Green Hostages Not Rescued'
ps_txt_objective_hostage_resc		= 'Rescuing a Hostage'
ps_txt_objective_hostage_kill		= 'Killing a Hostage'


################################################
# Do not edit below this line !!!!!!!!!!!!!!!!!!
################################################

ps_stats_calc_mode		= 1				# 1 - By steam, 2 - By name, 3 - By ip   (Updated from PS3.1 on init)
ps_stats_include_bots	= 0				# Include bots with statistics?
ps_stats_minplayers     = 4				# Minimum players on server to calc stats
ps_stats_maxdays		= 30			# Max days calculating stats
ps_stats_max_pl_sess	= 15			# Max player sessions
ps_stats_base_skill		= 50			# Base skill for new player

plrsets = {}
admin_list = []
atb_rounds = 0
team_kdr_t = 0
team_kdr_ct = 0
sql_c = ''
info = es.AddonInfo()
info.name = 'Psychostats3.1 Ranks & Statistics'
info.version = '0.1.2b'
info.basename = 'psstats'
info.url = 'http://forums.mattie.info/cs/forums/viewtopic.php?t=30247'
info.author = 'Ch@meleon'
# ================================================================================== #
# ===============  M a i n   M o d u l e   A d d o n   S o u r c e  ================ #
# ================================================================================== #
def load():
	cst.init()
	cst.getAdminList()

def unload():
	cst.close()

def player_say(e):
	global ps_cmd_top, ps_cmd_session, ps_cmd_statsme, ps_cmd_kpd, ps_cmd_rank
	global admin_list

	chatcmd 	= e['text']
	userid 		= e['userid']
	uid			= cst.getUniqueId(userid)
	name 		= es.getplayername(userid)


	# === TOP === #
	if(chatcmd == ps_cmd_top):
		showtop10(userid)

	# === RANK === #
	if(chatcmd == ps_cmd_rank):
		uid		= cst.getUniqueId(userid)
		data	= stats.getPlayerData(uid)
		es.msg( str(name) + ' is on place ' + str(data[1]) + ' of ' + str(data[5]) + ' with ' + str(data[3]) + ' points.')


	# === SESSION / KPD / STATSME === #
	if(chatcmd == ps_cmd_session):
		showkpd(userid)
	if(chatcmd == ps_cmd_statsme):
		showstatsme(userid)
	if(chatcmd == ps_cmd_kpd):
		showkpd(userid)

	if(chatcmd =='psatb'):
		if uid in admin_list:
			cmdtrigger('psatb')
	if(chatcmd =='psmover'):
		if uid in admin_list:
			cmdtrigger('psmover')

def cmdtrigger(cmd):
	global ps_atb
	global ps_atb_mover
	if cmd == 'psatb':
		ps_atb = 1 - ps_atb
		if ps_atb == 0:
			es.msg('PS-Autobalance is switched OFF')
		else:
			es.msg('PS-Autobalance is switched ON')
	if cmd == 'psmover':
		ps_atb_mover = 1 - ps_atb_mover
		if ps_atb_mover == 0:
			es.msg('PS-Autobalance players swapper is switched OFF')
		else:
			es.msg('PS-Autobalance players swapper is switched ON')

def menuhandler(userid, choice, popupname):
	global plrsets
	uid	= cst.getUniqueId(userid)
	if popupname == 'top10_popup':
		if choice == 8:
			if plrsets[uid,'top10_prev'] == 1:
				showtop10(userid,plrsets[uid,'top10_from']-20)
		if choice == 9:
			if plrsets[uid,'top10_next'] == 1:
				showtop10(userid,plrsets[uid,'top10_from'])

#top10
def showtop10(userid,startfrom = 0):
	global sql_c
	global plrsets
	q 		= sql_c.cursor()
	uid	= cst.getUniqueId(userid)
	plrsets[uid,'top10_from'] = startfrom + 10
	top10popup = popuplib.create('top10_popup')
	top10popup.addline('->1 - Top Players')
	top10popup.addline('-------------------------------')
	q.execute('SELECT MAX( pln.name ) name, plr.skill, (plr.skill - plr.prevskill )skilldiff, SUM( pld.kills ) , SUM( pld.deaths )  FROM `ps_plr` plr, `ps_plr_ids_name` pln, `ps_plr_data` pld WHERE pln.plrid = plr.plrid AND pld.plrid = plr.plrid AND pln.totaluses = ( SELECT max( totaluses ) FROM ps_plr_ids_name n WHERE n.plrid = pld.plrid ) GROUP BY pln.name, plr.skill, plr.prevskill ORDER BY plr.rank  LIMIT ' + str(startfrom) +',11')
	numrows = int(q.rowcount)
	nextp = 0
	for x in range(0, numrows):
		t = x + 1 + startfrom
		if(t < 10):
			posr = '0' + str(t)
		else:
			posr = str(t)

		c = q.fetchone()
		name = c[0]
		pts = c[1]
		ptsdif = c[2]
		if (ptsdif > 0):
			ptsdif = '+' + str(ptsdif)
		if (c[4] == 0):
			kdr = "%.2f" % round(float(c[3])/float(1),2)
		else:
			kdr = "%.2f" % round(float(c[3])/float(c[4]),2)
		if x<10:
			top10popup.addline(str(posr)+' '+str(name) +' ('+str(pts)+') , KDR: '+str(kdr))
		else:
			nextp = 1

	top10popup.addline('-------------------------------')
	plrsets[uid,'top10_prev'] = 0
	plrsets[uid,'top10_next'] = 0
	if startfrom>0:
		top10popup.addline('->8 - Prev')
		plrsets[uid,'top10_prev'] = 1
	if nextp>0:
		top10popup.addline('->9 - Next')
		plrsets[uid,'top10_next'] = 1
	top10popup.addline('->0 - Exit')
	top10popup.menuselect = menuhandler
	top10popup.send(userid)
	q.close()

#statsme
def showstatsme(userid):
	global rankPopup
	uid				= cst.getUniqueId(userid)
	data 			= stats.getPlayerData(uid)
	rank			= data[1]
	rank_old		= data[2]
	skill 			= data[3]
	skill_old		= data[4]
	plrcnt			= data[5]
	plr_kills		= data[6]
	plr_deaths		= data[7]
	plr_hskills		= data[8]
 	plr_ffkills		= data[9]
	plr_ffdeaths	= data[10]
	plr_kills_str	= data[11]
	plr_deaths_str	= data[12]
	plr_suicides	= data[13]
	plr_games		= data[14]
	plr_rounds		= data[15]
	plr_online		= data[16]
	plr_ctkills		= data[17]
	plr_tkills		= data[18]
	plr_ctdeaths	= data[19]
	pld_tdeaths		= data[20]
	pld_bomb_def_att= data[21]
	pld_bomb_def_def= data[22]
	pld_bomb_exp	= data[23]
	pld_bomb_pl		= data[24]
	pld_bomd_sp		= data[25]
	pld_killhost	= data[26]
	pld_reschost	= data[27]
	pld_touchhost	= data[28]
	pld_ctwon		= data[29]
	pld_ctlost		= data[30]
	pld_twon		= data[31]
	pld_tlost		= data[32]
	plr_s_points	= data[33]
	plr_s_kills		= data[34]
	plr_s_deaths	= data[35]
	plr_s_hk		= data[36]
	plr_s_ffkills	= data[37]
	prl_s_ffdeaths	= data[38]
	plr_s_suicides	= data[39]

	rankchange = rank_old - rank
	if(rankchange > 0):
		rc = '+' + str(rankchange)
	elif(rankchange < 0):
		rc = str(rankchange)
	else:
		rc = ''

	skillchange = skill - skill_old
	if(skillchange > 0):
		skc = '+' + str(skillchange)
	elif(skillchange < 0):
		skc = str(skillchange)
	else:
		skc = ''

	if (plr_deaths == 0):
		kdr = "%.2f" % round(float(plr_kills)/float(1),2)
	else:
		kdr = "%.2f" % round(float(plr_kills)/float(plr_deaths),2)

	t_rounds = pld_twon + pld_tlost
	ct_rounds = pld_ctwon + pld_ctlost
	if (t_rounds > ct_rounds):
		pref_team = 'T'
	else:
		pref_team = 'CT'

	try:
		kpm = "%.2f" % round( float(plr_kills) / float(plr_online) * 60 ,2)
	except:
		kpm = "0.00"

	rankPopup = popuplib.create('rank_popup')
	rankPopup.addline('->1 - Player Rundown')
	rankPopup.addline('      Position ' + str(rank) + ' ('+rc+')' + ' of '+str(plrcnt))
	rankPopup.addline('      Skill ' + str(skill) + ' ('+skc+')' +' points')
	rankPopup.addline('      Total Games ' + str(plr_games))
	rankPopup.addline('      Total Rounds ' + str(plr_rounds))
	rankPopup.addline('  ')
	rankPopup.addline('->2 - Kill Profile')
	rankPopup.addline('      KDR: ' +kdr)
	rankPopup.addline('      Kills per minute: ' + str(kpm))
	rankPopup.addline('      Kill Streak: ' + str(plr_kills_str))
	rankPopup.addline('      Death Streak: ' + str(plr_deaths_str))
	rankPopup.addline('  ')
	rankPopup.addline('->3 - Team Profile')
	rankPopup.addline('      Prefered team: ' + pref_team)
	rankPopup.addline('      ' + str(pld_twon) + ' T Wins')
	rankPopup.addline('      ' + str(pld_tlost) + ' T Loses')
	rankPopup.addline('      ' + str(pld_ctwon) + ' CT Wins')
	rankPopup.addline('      ' + str(pld_ctlost) + ' CT Loses')
	rankPopup.addline('  ')
	rankPopup.addline('->4 - Action Profile')
	rankPopup.addline('    ' + str(pld_bomb_pl) + ' Bombs Planted')
	rankPopup.addline('    ' + str(pld_bomb_def_def) + ' Bombs Defused')
	rankPopup.addline('    ' + str(pld_reschost) + ' Hostages Rescued')
	rankPopup.addline('  ')

	rankPopup.send(userid)


#session, kpd
def showkpd(userid):
	global rankPopup
	uid				= cst.getUniqueId(userid)
	data 			= stats.getPlayerData(uid)
	rank			= data[1]
	rank_old		= data[2]
	skill 			= data[3]
	skill_old		= data[4]
	plrcnt			= data[5]
	plr_kills		= data[6]
	plr_deaths		= data[7]
	plr_hskills		= data[8]
 	plr_ffkills		= data[9]
	plr_ffdeaths	= data[10]
	plr_kills_str	= data[11]
	plr_deaths_str	= data[12]
	plr_suicides	= data[13]
	plr_games		= data[14]
	plr_rounds		= data[15]
	plr_online		= data[16]
	plr_ctkills		= data[17]
	plr_tkills		= data[18]
	plr_ctdeaths	= data[19]
	pld_tdeaths		= data[20]
	pld_bomb_def_att= data[21]
	pld_bomb_def_def= data[22]
	pld_bomb_exp	= data[23]
	pld_bomb_pl		= data[24]
	pld_bomd_sp		= data[25]
	pld_killhost	= data[26]
	pld_reschost	= data[27]
	pld_touchhost	= data[28]
	pld_ctwon		= data[29]
	pld_ctlost		= data[30]
	pld_twon		= data[31]
	pld_tlost		= data[32]
	plr_s_points	= data[33]
	plr_s_kills		= data[34]
	plr_s_deaths	= data[35]
	plr_s_hk		= data[36]
	plr_s_ffkills	= data[37]
	prl_s_ffdeaths	= data[38]
	plr_s_suicides	= data[39]

	try:
		hp = float (100 / float(plr_kills))
		hpc = int( float(hp) * float(plr_hskills))
	except:
		hpc = '0'

	rankchange = rank_old - rank
	if(rankchange > 0):
		rc = '+' + str(rankchange)
	elif(rankchange < 0):
		rc = str(rankchange)
	else:
		rc = ''

	if (plr_deaths == 0):
		kdr = "%.2f" % round(float(plr_kills)/float(1),2)
	else:
		kdr = "%.2f" % round(float(plr_kills)/float(plr_deaths),2)

	if (plr_s_points > 0):
		plr_s_points = '+' + str(plr_s_points)

	rankPopup = popuplib.create('rank_popup')
	rankPopup.addline('->1 - Total Ranking')
	rankPopup.addline('      Position ' + str(rank) + ' of '+str(plrcnt))
	rankPopup.addline('      ' + str(skill) + ' Points')
	rankPopup.addline('      ' + str(plr_kills) + ' : ' + str(plr_deaths) + ' Frags')
	rankPopup.addline('      ' + str(plr_hskills) + ' (' + str(hpc) + '%) Headshots')
	rankPopup.addline('      ' + kdr + ':' + ' KDR')
	rankPopup.addline('  ')
	rankPopup.addline('->2 - This Session')
	rankPopup.addline('      ' + str(plr_s_points) + ' Points')
	rankPopup.addline('      ' + str(plr_s_kills) + ' : ' + str(plr_s_deaths) + ' Frags')
	rankPopup.addline('      ' + str(rc) + ' Positions')
	rankPopup.addline('      ' + str(plr_s_hk) + ' Headshots')
	rankPopup.addline('  ')
	rankPopup.addline('->3 - Achievements')
	rankPopup.addline('    ' + str(plr_ffkills) + ' Teamkills')
	rankPopup.addline('    ' + str(plr_suicides) + ' Suicides')
	rankPopup.addline('    ' + str(pld_bomb_pl) + ' Bombs Planted')
	rankPopup.addline('    ' + str(pld_bomb_def_def) + ' Bombs Defused')
	rankPopup.addline('    ' + str(pld_reschost) + ' Hostages Rescued')
	rankPopup.addline('    ' + str(pld_killhost) + ' Hostages Killed')
	rankPopup.addline('  ')

	rankPopup.send(userid)


def player_activate(ev):
	global plrsets
	userid 		= ev['userid']
	uid			= cst.getUniqueId(userid)
	name = es.getplayername(userid)
	if uid in admin_list and ps_admin_anounce==1:
		es.msg('#multi','#green[PS-STATS]: #default [ADMIN] ' + name + ' join to server!')



def round_start(ev):
	atb()


# ================================================================================== #
# =========================== Auto Team Balance Block ============================== #
# ================================================================================== #
def atb():
	global ps_atb, ps_atb_minplayers, ps_atb_rounds, atb_rounds
	if ps_atb>0 and es.getplayercount()>=ps_atb_minplayers:
		atb_calc_balance()
		atb_rounds = atb_rounds + 1
		if atb_rounds >= ps_atb_rounds:
			atb_rounds = 0
			res = atb_calc()
		else:
			if ps_atb_anounce>=2:
				es.msg('#multi','#green[PS-ATB]: #default ' + str(ps_atb_rounds-atb_rounds) + ' round(s) remains to rebalance teams')
		show_team_balance()

def atb_calc_balance():
	global team_kdr_t, team_kdr_ct
	team_kdr_t = 0
	team_kdr_ct = 0
	team_t_plrs = 0
	team_ct_plrs = 0
	myPlayerList = playerlib.getPlayerList('#all')
	for ply in myPlayerList:
		userid = int(ply.userid)
		name = es.getplayername(userid)
		uid	= cst.getUniqueId(userid)
		try:
			kdr = plrsets[uid,'kdr']
		except:
			if not es.isbot(userid) or ps_stats_include_bots==1:
				data = stats.getPlayerData(uid)
				try:
					plr_kills = data[6]
					plr_deaths	= data[7]
				except:
					plr_kills = 1
					plr_deaths	= 1
			else:
				plr_kills = 1
				plr_deaths	= 1
			if (plr_deaths == 0):
				kdr = 0
			else:
				kdr = float(plr_kills)/float(plr_deaths)
			if (es.isbot(userid)) and (ps_stats_include_bots == 0):
				kdr = 1
			plrsets[uid,'kdr'] = kdr
		if ply.attributes['teamid']== 2:
			team_t_plrs = team_t_plrs + 1
			team_kdr_t = team_kdr_t + kdr
		if ply.attributes['teamid']== 3:
			team_ct_plrs = team_ct_plrs + 1
			team_kdr_ct = team_kdr_ct + kdr

def show_team_balance():
	global team_kdr_t, team_kdr_ct, ps_atb_anounce
	if ps_atb_anounce>=1:
		es.msg('#multi','#green[PS-ATB]: #default T-Team KDR-Skill #lightgreen' + "%.2f" % round(team_kdr_t,2) +'#default - #lightgreen' + "%.2f" % round(team_kdr_ct,2) + '#default CT-team KDR-Skill')

def atb_calc():
	global team_kdr_t, team_kdr_ct
	global plrsets
	global ps_atb
	global ps_atb_minplayers
	global ps_atb_diff
	global ps_atb_mover
	global ps_stats_include_bots
	global ps_atb_anounce
	swap = 0
	swaped = 0
	if ps_atb>0 and es.getplayercount()>=ps_atb_minplayers:
		team_new_kdr_t = team_kdr_t
		team_new_kdr_ct = team_kdr_ct
		swap = 0
		swaped = 0
		min_atb_diff = abs(team_kdr_t - team_kdr_ct)
		if team_kdr_t> team_kdr_ct + ps_atb_diff:
			swap = 1
			swap_plrs = {'ct':-1,'ct2':-1,'t':-1,'t2':-1,'diff':min_atb_diff}
			pListT = playerlib.getPlayerList('#t')
			for plyT in pListT:
				Tuid = cst.getUniqueId(int(plyT.userid))
				T_kdr = plrsets[Tuid,'kdr']
				#check if needed move 1 terr
				if team_t_plrs>team_ct_plrs:
					diff = abs((team_kdr_ct + T_kdr) - (team_kdr_t - T_kdr))
					if diff < swap_plrs['diff']:
						swap_plrs['t'] = int(plyT.userid)
						swap_plrs['ct'] = -1
						swap_plrs['diff'] = diff
						team_new_kdr_t = team_kdr_t - T_kdr
						team_new_kdr_ct = team_kdr_ct + T_kdr
				#check if needed move 1 terr and 1 ct
				pListCT = playerlib.getPlayerList('#ct')
				for plyCT in pListCT:
					CTuid = cst.getUniqueId(int(plyCT.userid))
					CT_kdr = plrsets[CTuid,'kdr']
					diff = abs((team_kdr_ct + T_kdr - CT_kdr) - (team_kdr_t + CT_kdr - T_kdr))
					if diff < swap_plrs['diff']:
						swap_plrs['t'] = int(plyT.userid)
						swap_plrs['ct'] = int(plyCT.userid)
						swap_plrs['diff'] = diff
						team_new_kdr_t = team_kdr_t - T_kdr + CT_kdr
						team_new_kdr_ct = team_kdr_ct - CT_kdr + T_kdr
			if swap_plrs['t']<>-1:
				if ps_atb_anounce>=1:
					es.msg('#multi','#green[PS-ATB]: #default Player ' + es.getplayername(swap_plrs['t']) + ' moved from T to CT')
				if ps_atb_mover==1:
					cst.changeteam(swap_plrs['t'],'3')
					swaped = 1
			else:
				if ps_atb_anounce>=2:
					es.msg('#multi','#green[PS-ATB]: #default No variants to swap players')
			if swap_plrs['ct']<>-1:
				if ps_atb_anounce>=1:
					es.msg('#multi','#green[PS-ATB]: #default Player ' + es.getplayername(swap_plrs['ct']) + ' moved from CT to T')
				if ps_atb_mover==1:
					cst.changeteam(swap_plrs['ct'],'2')



		if team_kdr_ct> team_kdr_t + ps_atb_diff:
			swap = 1
			swap_plrs = {'ct':-1,'ct2':-1,'t':-1,'t2':-1,'diff':min_atb_diff}
			pListCT = playerlib.getPlayerList('#ct')
			for plyCT in pListCT:
				CTuid = cst.getUniqueId(int(plyCT.userid))
				CT_kdr = plrsets[CTuid,'kdr']
				#check swap 1 ct
				if team_ct_plrs>=team_t_plrs:
					diff = abs((team_kdr_t + CT_kdr) - (team_kdr_ct - CT_kdr))
					if diff < swap_plrs['diff']:
						swap_plrs['ct'] = int(plyCT.userid)
						swap_plrs['diff'] = diff
						team_new_kdr_t = team_kdr_t + CT_kdr
						team_new_kdr_ct = team_kdr_ct - CT_kdr
				#check swap 1 t and 1 ct
				pListT = playerlib.getPlayerList('#t')
				for plyT in pListT:
					Tuid = cst.getUniqueId(int(plyT.userid))
					T_kdr = plrsets[Tuid,'kdr']
					diff = abs((team_kdr_t + CT_kdr - T_kdr) - (team_kdr_ct + T_kdr - CT_kdr))
					#cst.log( str(CT_kdr) + ' ' + str(T_kdr) + ' ' +str(diff) + ' ' + es.getplayername(plyCT.userid) + ' ' + es.getplayername(plyT.userid))
					if diff < swap_plrs['diff']:
						swap_plrs['t'] = int(plyT.userid)
						swap_plrs['ct'] = int(plyCT.userid)
						swap_plrs['diff'] = diff
						team_new_kdr_t = team_kdr_t - T_kdr + CT_kdr
						team_new_kdr_ct = team_kdr_ct - CT_kdr + T_kdr
			if swap_plrs['ct']<>-1:
				if ps_atb_anounce>=1:
					es.msg('#multi','#green[PS-ATB]: #default Player ' + es.getplayername(swap_plrs['ct']) + ' moved from CT to T')
				if ps_atb_mover==1:
					cst.changeteam(swap_plrs['ct'],'2')
					swaped = 1
			else:
				if ps_atb_anounce>=2:
					es.msg('#multi','#green[PS-ATB]: #default No variants to swap players')
			if swap_plrs['t']<>-1:
				if ps_atb_anounce>=1:
					es.msg('#multi','#green[PS-ATB]: #default Player ' + es.getplayername(swap_plrs['t']) + ' moved from T to CT')
				if ps_atb_mover==1:
					cst.changeteam(swap_plrs['t'],'3')

		if swap == 0:
			if ps_atb_anounce>=1:
				es.msg('#multi','#green[PS-ATB]: #default Teams are balanced. No needed to swap')
		team_kdr_t = team_new_kdr_t
		team_kdr_ct = team_new_kdr_ct
	return swaped

# ================================================================================== #
# =================== A d d o n   C l a s s e s   L i b r a r y ==================== #
# ================================================================================== #
class stats(object):

	def getPlayerData(self, uid):
		q = sql_c.cursor()
		cst.log(str(uid))
		query = ' SELECT pl.plrid, pl.rank, pl.prevrank, pl.skill, pl.prevskill, ( SELECT COUNT( plrid ) cnt FROM `ps_plr`) AS plr_cnt, pld.kills, pld.deaths, pld.hskills, pld.ffkills, pld.ffdeaths, pld.kills_streak, pld.deaths_streak, pld.suicides, pld.games, pld.rounds, pld.onlinetime, pld.ctkills , pld.terroristkills, pld.ctdeaths, pld.terroristdeaths, pld.bomd_def_att, pld.bomd_def, pld.bomb_exp, pld.bomb_pl, pld.bomd_sp, pld.killhost, pld.reschost, pld.touchhost, pld.ctwon, pld.ctlost, pld.twon,  pld.tlost, (ps.skill - ps.prevskill) s_points, ps.kills s_kills, ps.deaths s_deaths, ps.headshotkills s_hk, ps.ffkills s_ffkills, ps.ffdeaths s_ffdeaths, ps.suicides s_suicides '
		query = query + ' FROM `ps_plr` pl, `ps_plr_sessions` ps, ( SELECT pdt.plrid, SUM( pdt.kills ) kills, SUM( pdt.deaths ) deaths, SUM(pdt.headshotkills) hskills,SUM( pdt.ffkills ) ffkills, SUM( pdt.ffdeaths ) ffdeaths, MAX( pdt.kills_streak ) kills_streak, MAX( pdt.deaths_streak ) deaths_streak, SUM( pdt.suicides ) suicides, SUM( pdt.games ) games, SUM( pdt.rounds ) rounds, SUM( pdt.onlinetime ) onlinetime, SUM(pdts.ctkills) ctkills ,SUM(pdts.terroristkills) terroristkills,SUM(pdts.ctdeaths) ctdeaths,SUM(pdts.terroristdeaths) terroristdeaths,SUM(pdts.bombdefuseattempts) bomd_def_att,SUM(pdts.bombdefused) bomd_def,SUM(pdts.bombexploded) bomb_exp,SUM(pdts.bombplanted) bomb_pl,SUM(pdts.bombspawned) bomd_sp,SUM(pdts.killedhostages) killhost,SUM(pdts.rescuedhostages) reschost,SUM(pdts.touchedhostages) touchhost, '
		query = query + ' SUM(pdts.ctwon) ctwon,SUM(pdts.ctlost) ctlost,SUM(pdts.terroristwon) twon, SUM(pdts.terroristlost) tlost FROM `ps_plr_data` pdt, `ps_plr_data_halflife_cstrike` pdts WHERE pdts.dataid = pdt.dataid GROUP BY pdt.plrid)pld WHERE ps.plrid = pl.plrid AND pl.uniqueid = "'+str(uid)+'" AND ps.dataid = (SELECT MAX( dataid ) FROM ps_plr_sessions psm WHERE psm.plrid = pl.plrid ) AND pld.plrid = pl.plrid '

		q.execute(query)
		n = int(q.rowcount)
		if(n < 1):
			data = '-1'
		else:
			data = q.fetchone()
		return data

stats = stats()

class cst(object):
	def init(self):
		self.log('-- Psychostats 3.1 - Ranks & Statistics Modification for CS:Source Servers --')
		self.mysql_connect()
		q = sql_c.cursor()
		q.execute('SET NAMES "UTF8"');
		q.execute('SET collation_connection="cp1251_general_ci"')
		q.execute('SET collation_server="cp1251_general_ci"')
		q.execute('SET character_set_client="utf8"')
		q.execute('SET character_set_connection="utf8"')
		q.execute('SET character_set_results="utf8"')
		q.execute('SET character_set_server="cp1251"')
		self.preloadSettings()
	def close(self):
		global sql_c
		sql_c.close()

	def log(self, msg):
		es.dbgmsg(0, msg);

	def mysql_connect(self):
		global sql_c
		self.log('Attempting to connect to [' + str(ps_mysql_hostname)+ ']...')
		try:
			sql_c = MySQLdb.connect(ps_mysql_hostname, ps_mysql_username, ps_mysql_password, ps_mysql_database)
			if(sql_c):
				self.log('Successfully connected to '+str(ps_mysql_hostname)+' with username "'+str(ps_mysql_username)+'".')

		except MySQLdb.Error, e:
			self.log('ERROR: Could not connect to the MySQL Server!')
			self.log('ERROR: ' + str(e))
			es.unload(info.basename)
			return

	def preloadSettings(self):
		q = sql_c.cursor()

		global ps_stats_calc_mode
		global ps_stats_include_bots
		global ps_stats_minplayers
		global ps_stats_maxdays
		global ps_stats_max_pl_sess

		# MAIN SETTINGS
		q.execute('SELECT var, value FROM `ps_config` WHERE section is null AND var is not null')
		numrows = int(q.rowcount)
		for x in range(0, numrows):
			c = q.fetchone()
			if (c[0]== 'uniqueid' ):
				if (c[1]=='worldid'):
					ps_stats_calc_mode = 1
				elif (c[1]=='name'):
					ps_stats_calc_mode = 2
				elif (c[1]=='ipaddr'):
					ps_stats_calc_mode = 3
			if (c[0]== 'ignore_bots' ):
				if (c[1]=='1'):
					ps_stats_include_bots = 0
				else:
					ps_stats_include_bots = 1
			if (c[0]== 'maxdays' ):
				ps_stats_maxdays = c[1]
			if (c[0]== 'plr_sessions_max' ):
				ps_stats_max_pl_sess = int(c[1])
			if (c[0]== 'baseskill' ):
				ps_stats_base_skill = int(c[1])

		# BONUS POINTS
		global ps_stats_multiplier
		global ps_stats_maxpoints
		global ps_stats_headshotbonus
		global ps_stats_teamkill_loss
		global ps_points_team_t_elim
		global ps_points_team_ct_elim
		global ps_points_team_bomb_bt
		global ps_points_team_bomb_d
		global ps_points_team_hostage_r
		global ps_points_team_hostage_k
		global ps_points_bomb_planted
		global ps_points_bomb_defused
		global ps_points_hostage_resc
		global ps_points_hostage_kill

		q.execute('SELECT * FROM `ps_config_plrbonuses` WHERE modtype = "" OR modtype = "cstrike"')

		# WEAPON POINTS
		global ps_bonus_weapon_glock
		global ps_bonus_weapon_usp
		global ps_bonus_weapon_p228
		global ps_bonus_weapon_deagle
		global ps_bonus_weapon_fiveseven
		global ps_bonus_weapon_elite
		global ps_bonus_weapon_m3
		global ps_bonus_weapon_xm1014
		global ps_bonus_weapon_tmp
		global ps_bonus_weapon_mac10
		global ps_bonus_weapon_mp5navy
		global ps_bonus_weapon_ump45
		global ps_bonus_weapon_p90
		global ps_bonus_weapon_famas
		global ps_bonus_weapon_galil
		global ps_bonus_weapon_ak47
		global ps_bonus_weapon_scout
		global ps_bonus_weapon_m4a1
		global ps_bonus_weapon_sg550
		global ps_bonus_weapon_g3sg1
		global ps_bonus_weapon_awp
		global ps_bonus_weapon_sg552
		global ps_bonus_weapon_aug
		global ps_bonus_weapon_m249
		global ps_bonus_weapon_hegrenade
		global ps_bonus_weapon_flashbang
		global ps_bonus_weapon_smokegrenade
		global ps_bonus_weapon_knife

		q.execute('SELECT * FROM `ps_weapon`')

		q.close()

	def getAdminList(self):
		global admin_list, ps_stats_calc_mode
		es.keygroupcreate("clients")
		clients = keyvalues.getKeyGroup("clients")
		try:
			clients.load("cfg/mani_admin_plugin/clients.txt")
		except:
			return 0
		if ps_stats_calc_mode == 1:
			try:
				admin_list = [x['steam'] for x in clients['players']]
			except:
				admin_list = []
		if ps_stats_calc_mode == 2:
			try:
				admin_list = [x['name'] for x in clients['players']]
			except:
				admin_list = []
		if ps_stats_calc_mode == 3:
			try:
				admin_list = [x['ip'] for x in clients['players']]
			except:
				admin_list = []

		#es.dbgmsg(0, admin_list)

	def getUniqueId(self, userid):
		global ps_stats_calc_mode
		if (ps_stats_calc_mode == 1):
			return str(es.getplayersteamid(userid))
		elif (ps_stats_calc_mode == 2):
			return str(es.getplayername(userid))
		else:
			plr = playerlib.getPlayer(userid)
			return str(plr.attributes['address'])

	def getModelNum(self, userid):
		player  = playerlib.getPlayer(userid)
		mdl = player.attributes['model']
		cst.log(es.getplayername(userid) + ' ' + mdl)
		if mdl=='models/player/t_phoenix.mdl':
			n = 1
		elif mdl=='models/player/t_leet.mdl':
			n = 2
		elif mdl=='models/player/t_arctic.mdl':
			n = 3
		elif mdl=='models/player/t_guerilla.mdl':
			n = 4
		elif mdl=='models/player/ct_urban.mdl':
			n = 1
		elif mdl=='models/player/ct_gsg9.mdl':
			n = 2
		elif mdl=='models/player/ct_sas.mdl':
			n = 3
		elif mdl=='models/player/ct_gign.mdl':
			n = 4
		else:
			n = 1
		return n

	def setModelNum(self, userid, team, mdl):
		player  = playerlib.getPlayer(userid)
		if team=='2':
			if mdl == 1:
				player.set('model','models/player/t_phoenix.mdl')
			elif mdl == 2:
				player.set('model','models/player/t_leet.mdl')
			elif mdl == 3:
				player.set('model','models/player/t_arctic.mdl')
			elif mdl == 4:
				player.set('model','models/player/t_guerilla.mdl')
			else:
				player.set('model','models/player/t_phoenix.mdl')
		if team=='3':
			if mdl == 1:
				player.set('model','models/player/ct_urban.mdl')
			elif mdl == 2:
				player.set('model','models/player/ct_gsg9.mdl')
			elif mdl == 3:
				player.set('model','models/player/ct_sas.mdl')
			elif mdl == 4:
				player.set('model','models/player/ct_gign.mdl')
			else:
				player.set('model','models/player/ct_urban.mdl')
		return 1

	def changeteam(self, userid, teamid):
		es.server.queuecmd('est_team %s %s' % (userid,teamid))
		es.server.queuecmd('est_spawn %s 1'%userid)

cst = cst()
# ================================================================================== #
